extends CharacterBody2D


const SPEED = 300.0
const JUMP_VELOCITY = -400.0
const PUSH_FORCE = 700

var faceLeft = false
var living = true

# can i push right or left
var pushLeftEnabled = false
var pushRightEnabled = false
@onready var right_ray: RayCast2D = $RightRay
@onready var left_ray: RayCast2D = $LeftRay
@onready var marker_right: Node2D = $MarkerRight
@onready var marker_left: Node2D = $MarkerLeft
@onready var playerSprite: AnimatedSprite2D = $AnimatedSprite2D

var pushTarget

var bullet = preload("res://scenes/bullet.tscn")

func killPlayer():
	print("kill the player")
	if living:
		living = false
		#play death animation
		playerSprite.play("death")
	
func _physics_process(delta: float) -> void:
	if living:
		# Add the gravity.
		if not is_on_floor():
			velocity += get_gravity() * delta

		# Handle jump.
		if Input.is_action_just_pressed("ui_accept") and is_on_floor():
			velocity.y = JUMP_VELOCITY
		
		if Input.is_action_just_pressed("Shove") && pushLeftEnabled && faceLeft:
			pushTarget.apply_central_impulse(Vector2(-1,0) * PUSH_FORCE * 1.5)
			pushLeftEnabled = false
			
		if Input.is_action_just_pressed("Shove") && pushRightEnabled && not faceLeft:
			pushTarget.apply_central_impulse(Vector2(1,0) * PUSH_FORCE * 1.5)
			pushRightEnabled=false
		
		if Input.is_action_just_pressed("shoot"):
			if faceLeft:
				# mybullet.setSpeed(-700)
				#mybullet.transform = marker_left.global_transform
				%SceneManager.placeBullet(-700, marker_left.global_transform)
			else:
				#mybullet.transform = marker_right.global_transform
				%SceneManager.placeBullet(700, marker_right.global_transform)

		# Get the input direction and handle the movement/deceleration.
		# As good practice, you should replace UI actions with custom gameplay actions.
		var direction := Input.get_axis("ui_left", "ui_right")
		if direction <0:
			faceLeft = true
			playerSprite.flip_h = true
		if direction >0:
			faceLeft = false
			playerSprite.flip_h = false
			
		if direction:
			velocity.x = direction * SPEED
		else:
			velocity.x = move_toward(velocity.x, 0, SPEED)
		
		if is_on_floor():
			if direction == 0:
				playerSprite.play("idle")
			else:
				playerSprite.play("run")
		else:
			playerSprite.play("jump")
				
		move_and_slide()
		for i in get_slide_collision_count():
			var c = get_slide_collision(i)
			if c.get_collider() is RigidBody2D:
				c.get_collider().apply_central_impulse(-c.get_normal()* 100)
		
		if left_ray.is_colliding():
			var collider = left_ray.get_collider()
			if collider is Node:
				if collider.is_in_group("pushables"):
					pushLeftEnabled = true
					pushTarget = collider
		else:
			#do something else
			pushLeftEnabled = false
			
		if right_ray.is_colliding():
			var collider = right_ray.get_collider()
			if collider is Node:
				if collider.is_in_group("pushables"):
					pushRightEnabled = true
					pushTarget = collider
		else:
			pushRightEnabled = false
